using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace SevenCitiesOfGoldUtility {
  public class Sprites {
    public Bitmap [] _normals = new Bitmap [12];
    public Bitmap [,] _forests = new Bitmap [16,3];
    public Bitmap [] _mountains = new Bitmap [12];
    public Bitmap [] _swamps = new Bitmap [16];
    public Bitmap [] _natives = new Bitmap [12];
    public Bitmap [] _buildings = new Bitmap [4];

    public Sprites () {
      Bitmap sprites = Resources.Sprites;
      for (int i = 0; i < 12; i++) {
        _normals [i] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 0 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
      }
      for (int i = 0; i < 16; i++) {
        _forests [i,0] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 1 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
      }
      for (int i = 0; i < 16; i++) {
        _forests [i, 1] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 2 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
      }
      for (int i = 0; i < 16; i++) {
        _forests [i, 2] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 3 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
      }
      for (int i = 0; i < 12; i++) {
        _mountains [i] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 4 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
      }
      for (int i = 0; i < 16; i++) {
        _swamps [i] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 5 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
      }
      for (int i = 0; i < 12; i++) {
        _natives [i] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 6 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
      }
      for (int i = 0; i < 4; i++) {
        _buildings [i] = sprites.Clone (new Rectangle (i * (Sprites.Width + 1) + 1, 7 * (Sprites.Height + 1) + 1, Sprites.Width, Sprites.Height), sprites.PixelFormat);
        _buildings [i].MakeTransparent (Color.FromArgb (255, 0, 255));
      }
    }

    public static int Width {
      get {
        return (16);
      }
    }

    public static int Height {
      get {
        return (16);
      }
    }

  }
}
